package supermercato_senza_interfacce;

import java.util.*;

public class Supermercato {
	
	private static final int MAX_CLIENTI = 100000;
	
	private Cliente[] clienti;
	private int numClienti; // contiene il numero di clienti presenti nel vettore
	private List<Acquisto> acquisti;
	private Map<String,Integer> puntiPerPremi;
	
	public Supermercato(){
		this(new Cliente[MAX_CLIENTI],0,new ArrayList<Acquisto>(),new HashMap<String,Integer>());
	}
	
	public Supermercato(Cliente[] C, int numC, List<Acquisto> l, Map<String,Integer> m){
		clienti = C;
		numClienti = numC;
		acquisti = l;
		puntiPerPremi = m;
	}
	
	
	// punto 1)
	public void aggiornaPunti(int codiceC, int punti){
		boolean trovato=false;
		for(int i=0; i<numClienti && !trovato; i++)
			if(clienti[i].getCodice()==codiceC){
				trovato=true;
				clienti[i].aggiungiPunti(punti);
			}
		if(!trovato)
			System.out.println("Errore: cliente non trovato!\n");
	}
	
	// punto 3)
	public void premiOttenibili(int punti){
		Iterator<String> i = puntiPerPremi.keySet().iterator();
		while(i.hasNext()){
			String premio = i.next();
			if(puntiPerPremi.get(premio) <= punti)
				System.out.println("Premio: "+premio+"\t punti: "+puntiPerPremi.get(premio)+"\n");
		}	
	}
	
	// punto 4)
	public Set<Cliente> clientiPiuFedeli(){
		Set<Cliente> clientiFedeli = new HashSet<Cliente>();
		int maxPunti = 0;
		for(int i=0; i<numClienti; i++){
			if(clienti[i].getPunti() == maxPunti)
				clientiFedeli.add(clienti[i]);
			else if(clienti[i].getPunti() > maxPunti){
				clientiFedeli = new HashSet<Cliente>();
				clientiFedeli.add(clienti[i]);
				maxPunti = clienti[i].getPunti();
			}
		}
		return clientiFedeli;
	}

}
